//--------------------------------------------------------
// * Prufer Sequence
//--------------------------------------------------------
#ifndef PRUFER_SEQ_H
#define PRUFER_SEQ_H

#include <iostream>
#include <fstream>
#include <vector>
#include <deque>
#include <cstdlib>

class Prufer{
public:
	Prufer(){};
	Prufer(std::vector<int>::size_type);
	Prufer(const Prufer&);
	Prufer(const std::vector<int>&);

	Prufer& operator=(const Prufer&);
	Prufer& operator=(const std::vector<int>&);

	std::vector<int>::iterator begin();
	std::vector<int>::const_iterator begin() const;
	std::vector<int>::iterator end();
	std::vector<int>::const_iterator end() const;
	std::vector<int>::reverse_iterator rbegin();
	std::vector<int>::const_reverse_iterator rbegin() const;
	std::vector<int>::reverse_iterator rend();
	std::vector<int>::const_reverse_iterator rend() const;

	bool include(int) const;
	bool empty() const;
	std::vector<int>::size_type size() const;
	std::vector<int>::size_type max_size() const;
	void resize(std::vector<int>::size_type);
	void resize(std::vector<int>::size_type, int);
	std::vector<int>::size_type capacity() const;
	void reserve(std::vector<int>::size_type);

	int operator[](std::vector<int>::size_type) const;
	int& operator[](std::vector<int>::size_type);
	int at(std::vector<int>::size_type) const;
	int& at(std::vector<int>::size_type);
	std::vector<int>::iterator find(int);
	std::vector<int>::const_iterator find(int) const;
	int front() const;
	int& front();
	int back() const;
	int& back();

	void assign(std::vector<int>::iterator, std::vector<int>::iterator);
	void assign(std::vector<int>::size_type, int);
	void push_back(int);
	void pop_back();
	std::vector<int>::iterator insert(std::vector<int>::iterator, int);
	std::vector<int>::iterator insert(std::vector<int>::size_type, int);
	void insert(std::vector<int>::iterator, std::vector<int>::size_type, int);
	void insert(std::vector<int>::iterator, std::vector<int>::iterator, std::vector<int>::iterator);

	bool remove(int);
	std::vector<int>::iterator erase(std::vector<int>::iterator);
	std::vector<int>::iterator erase(std::vector<int>::size_type);
	std::vector<int>::iterator erase(std::vector<int>::iterator, std::vector<int>::iterator);
	void swap(Prufer&);
	void clear();
	void unique();

	std::vector<int>::allocator_type get_allocator() const;

	friend std::ostream& operator<<(std::ostream&, const Prufer&);

private:
	std::vector<int> data;
};

#include "prufer.cpp"
#endif
